{********************************************************************************}
{ Puzzle 1.0 - Juego bajo ms-dos, de tpico puzzle que le falta una pieza        }
{ Copyright (C) 2004  Gorka Surez Garca                                        }
{                                                                                }
{ This program is free software; you can redistribute it and/or                  }
{ modify it under the terms of the GNU General Public License                    }
{ as published by the Free Software Foundation; either version 2                 }
{ of the License, or (at your option) any later version.                         }
{                                                                                }
{ This program is distributed in the hope that it will be useful,                }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of                 }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  }
{ GNU General Public License for more details.                                   }
{                                                                                }
{ You should have received a copy of the GNU General Public License              }
{ along with this program; if not, write to the Free Software                    }
{ Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    }
{********************************************************************************}
program Puzzle;
uses Lesslib, crt;
{********************************************************************************}
const
   MAXX = 10;
   MAXY = 9;
   MAXC = 90;

type
   tTablero = array[1..MAXC] of tImagen;
   tTabpos  = array[1..MAXY, 1..MAXX] of integer;

var
   raton   : tRaton;
   tablero : tTablero;
   tabpos  : tTabpos;
   fondo   : tImagen;
   cursor  : tImagen;
   paleta  : tPaleta;
{   ferr    : text;}
{********************************************************************************}
procedure ActualizarPantalla;
var
   i, j, x, y: integer;
begin
   {Borrado de pantalla}
   M13hBorrarPantalla(0);
   M13hImagenPegar(54, 5, fondo);

   {Pintar fragmentos}
   for i := 1 to MAXY do
      for j := 1 to MAXX do
       begin
         x := 21*j+34; {20*(j-1)+j+54;}
         y := 21*i-15; {20*(i-1)+i+5;}
         M13hImagenPegar3(x, y, 20, 20, tablero[tabpos[i, j]]);
       end;

   RatonEstado(raton);
   M13hImagenPegar2(raton.x, raton.y, cursor, 0);

   M13hActualizarPantalla;
end;
{********************************************************************************}
procedure InitJuego;
var
   palaux     : tPaleta;
   imgaux     : tImagen;
   i, j, x, y : integer;
   color, num : byte;
   vector     : array[1..MAXC] of byte;
begin
   {Carga de las imagenes}
   M13hImagenCargarFichero('puzzle.bmp', imgaux, paleta);
   M13hImagenCargarFichero('cursor.bmp', cursor, palaux);

   {Carga de la paleta}
   M13hPaleta24a18(paleta);
   M13hPaletaCargar(paleta);

   {Cargar la imagen de fondo}
   M13hCrearImagen(224, 192, fondo);
   M13hLimpiarImagen(fondo, 0);
   color := M13hImagenDarPixel(0, 0, imgaux);
   for y := 0 to 189 do
      for x := 0 to 210 do
         M13hImagenPonPixel(x, y, fondo, color);

   {Copiamos los fragmentos del puzle}
   M13hImagenPegar(0, 0, imgaux);
   num := 1;
   for i := 1 to MAXY do
      for j := 1 to MAXX do
       begin
         M13hCrearImagen(32, 32, tablero[num]);
         M13hLimpiarImagen(tablero[num], 0);
         x := 21*j-20; {20*(j-1)+j;}
         y := 21*i-20; {20*(i-1)+i;}
         M13hImagenCopiar(x, y, 20, 20, tablero[num]);
         num := num + 1;
       end;

   {Colocamos aleatoriamente los fragmentos}
   for i := 1 to MAXC do
      vector[i] := i;

   randomize;
   for i := 1 to MAXY do
      for j := 1 to MAXX do
       begin
         repeat
            num := (random(MAXC) + 1);
         until vector[num] <> 0;

         tabpos[i, j] := vector[num];
         vector[num]  := 0;
       end;

   M13hBorrarPantalla(0);
   M13hImagenPegar(54, 5, imgaux);
   M13hActualizarPantalla; readkey;
   ActualizarPantalla;
end;
{--------------------------------------------------------------------------------}
procedure FinJuego;
var
   i: integer;
begin
   for i := 1 to MAXC do
      M13hBorrarImagen(tablero[i]);

   M13hBorrarImagen(fondo);
   M13hBorrarImagen(cursor);
end;
{********************************************************************************}
function DarTecla: integer;
var
   tecla: integer;
begin
   if keypressed then
    begin
      tecla := ord(readkey);
      if tecla = 0 then
         tecla := ord(readkey);
    end;

   DarTecla := tecla;
end;
{--------------------------------------------------------------------------------}
procedure MoverCasilla;
var
   casilla: integer;
   i, j: integer;
begin
   {Hallamos primero la casilla sobre la que esta}
   RatonEstado(raton);
   if raton.bi then
    begin
      j := trunc((raton.x - 34) / 21);
      i := trunc((raton.y + 15) / 21);

      {Comprobamos que este la casilla vacia en las proximidades}
      if (i in [1..MAXY]) and (j in [1..MAXX]) then
       begin
         casilla := tabpos[i, j];

         if (i - 1) > 0 then {La casilla de arriba}
          begin
            if tabpos[i-1, j] = 1 then
             begin
               tabpos[i, j]   := tabpos[i-1, j];
               tabpos[i-1, j] := casilla;
             end;
          end;

         if (i + 1) < 10 then {La casilla de abajo}
          begin
            if tabpos[i+1, j] = 1 then
             begin
               tabpos[i, j]   := tabpos[i+1, j];
               tabpos[i+1, j] := casilla;
             end;
          end;

         if (j - 1) > 0 then {La casilla de la izquierda}
          begin
            if tabpos[i, j-1] = 1 then
             begin
               tabpos[i, j]   := tabpos[i, j-1];
               tabpos[i, j-1] := casilla;
             end;
          end;

         if (j + 1) < 11 then {La casilla de la derecha}
          begin
            if tabpos[i, j+1] = 1 then
             begin
               tabpos[i, j]   := tabpos[i, j+1];
               tabpos[i, j+1] := casilla;
             end;
          end;
       end;
    end;
end;
{********************************************************************************}
procedure Juego;
var
   salir: boolean;
   tecla: integer;
begin
   repeat
      ActualizarPantalla;
      tecla := DarTecla;
      salir := (tecla = 27);
      MoverCasilla;
   until salir;
end;
{********************************************************************************}
begin
{   assign(ferr, 'err_out.txt');
   $I-
   append(ferr);
   $I+

   if IOResult <> 0 then
      rewrite(ferr);}

   if M13hActivar then
    begin
      if RatonActivar > 0 then
       begin
         RatonOcultar;
         RatonLimitar(0, 0, 304, 184);
         InitJuego;
         Juego;
         FinJuego;
       end;
      M13hDesactivar;
    end;

{   close(ferr);}
end.
{********************************************************************************}